Index: src/hist.c
===================================================================
--- src/hist.c	(revision 812b376c958b72e57bd5e21c1c8e29644b011809)
+++ src/hist.c	(revision 3c707f7bc0e941e111abd36240b790885ee3adc8)
@@ -1,19 +1,19 @@
 /*
-	 Copyright (C) 2003 Paul Brossier
+   Copyright (C) 2003 Paul Brossier
 
-	 This program is free software; you can redistribute it and/or modify
-	 it under the terms of the GNU General Public License as published by
-	 the Free Software Foundation; either version 2 of the License, or
-	 (at your option) any later version.
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
 
-	 This program is distributed in the hope that it will be useful,
-	 but WITHOUT ANY WARRANTY; without even the implied warranty of
-	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	 GNU General Public License for more details.
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
 
-	 You should have received a copy of the GNU General Public License
-	 along with this program; if not, write to the Free Software
-	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-	 */
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+*/
 
 #include "aubio_priv.h"
@@ -28,9 +28,9 @@
 
 struct _aubio_hist_t {
-	fvec_t * hist;
-	uint_t nelems;
-	uint_t channels;
-	fvec_t * cent;
-	aubio_scale_t *scaler;
+  fvec_t * hist;
+  uint_t nelems;
+  uint_t channels;
+  fvec_t * cent;
+  aubio_scale_t *scaler;
 };
 
@@ -39,28 +39,28 @@
  */
 aubio_hist_t * new_aubio_hist (smpl_t ilow, smpl_t ihig, uint_t nelems, uint_t channels){
-	aubio_hist_t * s = AUBIO_NEW(aubio_hist_t);
-	smpl_t step = (ihig-ilow)/(smpl_t)(nelems);
-	smpl_t accum = step;
-	uint_t i;
-	s->channels = channels;
-	s->nelems = nelems;
+  aubio_hist_t * s = AUBIO_NEW(aubio_hist_t);
+  smpl_t step = (ihig-ilow)/(smpl_t)(nelems);
+  smpl_t accum = step;
+  uint_t i;
+  s->channels = channels;
+  s->nelems = nelems;
   s->hist = new_fvec(nelems, channels);
-	s->cent = new_fvec(nelems, 1);
-	
-	/* use scale to map ilow/ihig -> 0/nelems */
-	s->scaler = new_aubio_scale(ilow,ihig,0,nelems);
-	/* calculate centers now once */
-	s->cent->data[0][0] = ilow + 0.5 * step;
-	for (i=1; i < s->nelems; i++, accum+=step )
-		s->cent->data[0][i] = s->cent->data[0][0] + accum;
-	
-	return s;	
+  s->cent = new_fvec(nelems, 1);
+
+  /* use scale to map ilow/ihig -> 0/nelems */
+  s->scaler = new_aubio_scale(ilow,ihig,0,nelems);
+  /* calculate centers now once */
+  s->cent->data[0][0] = ilow + 0.5 * step;
+  for (i=1; i < s->nelems; i++, accum+=step )
+    s->cent->data[0][i] = s->cent->data[0][0] + accum;
+
+  return s;
 }
 
 void del_aubio_hist(aubio_hist_t *s) {
   del_fvec(s->hist);
-	del_fvec(s->cent);
-	del_aubio_scale(s->scaler);
-	AUBIO_FREE(s);
+  del_fvec(s->cent);
+  del_aubio_scale(s->scaler);
+  AUBIO_FREE(s);
 }
 
@@ -68,97 +68,90 @@
  * do it
  */
-void aubio_hist_do (aubio_hist_t *s, fvec_t *input) 
-{
-	uint_t i,j;
-	sint_t tmp = 0;
-	aubio_scale_do(s->scaler, input);
-	/* reset data */
-	for (i=0; i < s->channels; i++)
-		for (j=0; j < s->nelems; j++) 
-			s->hist->data[i][j] = 0;
-	/* run accum */
-	for (i=0; i < input->channels; i++)
-		for (j=0;  j < input->length; j++)
-		{
-			tmp = (sint_t)FLOOR(input->data[i][j]);
-			if ((tmp >= 0) && (tmp < (sint_t)s->nelems))
-				s->hist->data[i][tmp] += 1;
-		}
+void aubio_hist_do (aubio_hist_t *s, fvec_t *input) {
+  uint_t i,j;
+  sint_t tmp = 0;
+  aubio_scale_do(s->scaler, input);
+  /* reset data */
+  for (i=0; i < s->channels; i++)
+    for (j=0; j < s->nelems; j++)
+      s->hist->data[i][j] = 0;
+  /* run accum */
+  for (i=0; i < input->channels; i++)
+    for (j=0;  j < input->length; j++)
+    {
+      tmp = (sint_t)FLOOR(input->data[i][j]);
+      if ((tmp >= 0) && (tmp < (sint_t)s->nelems))
+        s->hist->data[i][tmp] += 1;
+    }
 }
 
-void aubio_hist_do_notnull (aubio_hist_t *s, fvec_t *input) 
-{
-	uint_t i,j;
-	sint_t tmp = 0;
-	aubio_scale_do(s->scaler, input);
-	/* reset data */
-	for (i=0; i < s->channels; i++)
-		for (j=0; j < s->nelems; j++) 
-			s->hist->data[i][j] = 0;
-	/* run accum */
-	for (i=0; i < input->channels; i++)
-		for (j=0;  j < input->length; j++) 
-		{
-			if (input->data[i][j] != 0) {
-				tmp = (sint_t)FLOOR(input->data[i][j]);
-				if ((tmp >= 0) && (tmp < (sint_t)s->nelems))
-					s->hist->data[i][tmp] += 1;
-			}
-		}
+void aubio_hist_do_notnull (aubio_hist_t *s, fvec_t *input) {
+  uint_t i,j;
+  sint_t tmp = 0;
+  aubio_scale_do(s->scaler, input);
+  /* reset data */
+  for (i=0; i < s->channels; i++)
+    for (j=0; j < s->nelems; j++)
+      s->hist->data[i][j] = 0;
+  /* run accum */
+  for (i=0; i < input->channels; i++)
+    for (j=0;  j < input->length; j++) {
+      if (input->data[i][j] != 0) {
+        tmp = (sint_t)FLOOR(input->data[i][j]);
+        if ((tmp >= 0) && (tmp < (sint_t)s->nelems))
+          s->hist->data[i][tmp] += 1;
+      }
+    }
 }
 
 
-void aubio_hist_dyn_notnull (aubio_hist_t *s, fvec_t *input) 
-{
-	uint_t i,j;
-	sint_t tmp = 0;
-	smpl_t ilow = vec_min(input);
-	smpl_t ihig = vec_max(input);
-	smpl_t step = (ihig-ilow)/(smpl_t)(s->nelems);
-	
-	/* readapt */
-	aubio_scale_set(s->scaler, ilow, ihig, 0, s->nelems);
+void aubio_hist_dyn_notnull (aubio_hist_t *s, fvec_t *input) {
+  uint_t i,j;
+  sint_t tmp = 0;
+  smpl_t ilow = vec_min(input);
+  smpl_t ihig = vec_max(input);
+  smpl_t step = (ihig-ilow)/(smpl_t)(s->nelems);
 
-	/* recalculate centers */
-	s->cent->data[0][0] = ilow + 0.5f * step;
-	for (i=1; i < s->nelems; i++)
-		s->cent->data[0][i] = s->cent->data[0][0] + i * step;
+  /* readapt */
+  aubio_scale_set(s->scaler, ilow, ihig, 0, s->nelems);
 
-	/* scale */	
-	aubio_scale_do(s->scaler, input);
+  /* recalculate centers */
+  s->cent->data[0][0] = ilow + 0.5f * step;
+  for (i=1; i < s->nelems; i++)
+    s->cent->data[0][i] = s->cent->data[0][0] + i * step;
 
-	/* reset data */
-	for (i=0; i < s->channels; i++)
-		for (j=0; j < s->nelems; j++) 
-			s->hist->data[i][j] = 0;
-	/* run accum */
-	for (i=0; i < input->channels; i++)
-		for (j=0;  j < input->length; j++) 
-		{
-			if (input->data[i][j] != 0) {
-				tmp = (sint_t)FLOOR(input->data[i][j]);
-				if ((tmp >= 0) && (tmp < (sint_t)s->nelems))
-					s->hist->data[i][tmp] += 1;
-			}
-		}
+  /* scale */
+  aubio_scale_do(s->scaler, input);
+
+  /* reset data */
+  for (i=0; i < s->channels; i++)
+    for (j=0; j < s->nelems; j++)
+      s->hist->data[i][j] = 0;
+  /* run accum */
+  for (i=0; i < input->channels; i++)
+    for (j=0;  j < input->length; j++) {
+      if (input->data[i][j] != 0) {
+        tmp = (sint_t)FLOOR(input->data[i][j]);
+        if ((tmp >= 0) && (tmp < (sint_t)s->nelems))
+          s->hist->data[i][tmp] += 1;
+      }
+    }
 }
 
-void aubio_hist_weight (aubio_hist_t *s) 
-{
-	uint_t i,j;
-	for (i=0; i < s->channels; i++)
-		for (j=0; j < s->nelems; j++) {
-			s->hist->data[i][j] *= s->cent->data[0][j];
-		}
+void aubio_hist_weight (aubio_hist_t *s) {
+  uint_t i,j;
+  for (i=0; i < s->channels; i++)
+    for (j=0; j < s->nelems; j++) {
+      s->hist->data[i][j] *= s->cent->data[0][j];
+    }
 }
 
-smpl_t aubio_hist_mean (aubio_hist_t *s) 
-{
-	uint_t i,j;
-	smpl_t tmp = 0.0f;
-	for (i=0; i < s->channels; i++)
-		for (j=0; j < s->nelems; j++)
-			tmp += s->hist->data[i][j];
-	return tmp/(smpl_t)(s->nelems);
+smpl_t aubio_hist_mean (aubio_hist_t *s) {
+  uint_t i,j;
+  smpl_t tmp = 0.0f;
+  for (i=0; i < s->channels; i++)
+    for (j=0; j < s->nelems; j++)
+      tmp += s->hist->data[i][j];
+  return tmp/(smpl_t)(s->nelems);
 }
 
Index: src/hist.h
===================================================================
--- src/hist.h	(revision 812b376c958b72e57bd5e21c1c8e29644b011809)
+++ src/hist.h	(revision 3c707f7bc0e941e111abd36240b790885ee3adc8)
@@ -15,5 +15,5 @@
 	 along with this program; if not, write to the Free Software
 	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-	 */
+*/
 
 /** @file
@@ -34,9 +34,9 @@
 typedef struct _aubio_hist_t aubio_hist_t;
 
-/** histogram creation 
+/** histogram creation
  * \param flow minimum input
  * \param fhig maximum input
  * \param nelems number of histogram columns
- * \param channels number of channels 
+ * \param channels number of channels
  */
 aubio_hist_t * new_aubio_hist(smpl_t flow, smpl_t fhig, uint_t nelems, uint_t channels);
@@ -48,7 +48,7 @@
 void aubio_hist_do_notnull(aubio_hist_t *s, fvec_t * input);
 /** compute the mean of the histogram */
-smpl_t aubio_hist_mean(aubio_hist_t *s); 
+smpl_t aubio_hist_mean(aubio_hist_t *s);
 /** weight the histogram */
-void aubio_hist_weight(aubio_hist_t *s); 
+void aubio_hist_weight(aubio_hist_t *s);
 /** compute dynamic histogram for non-null elements */
 void aubio_hist_dyn_notnull (aubio_hist_t *s, fvec_t *input);