Index: tests/src/io/test-sink-multi.c
===================================================================
--- tests/src/io/test-sink-multi.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink-multi.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -7,4 +7,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -69,4 +71,7 @@
   del_aubio_source(i);
 beach_source:
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink.c
===================================================================
--- tests/src/io/test-sink.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -55,4 +57,7 @@
   del_fvec(vec);
 beach_fvec:
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink_apple_audio-multi.c
===================================================================
--- tests/src/io/test-sink_apple_audio-multi.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink_apple_audio-multi.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -75,4 +77,7 @@
   PRINT_ERR("aubio was not compiled with aubio_sink_apple_audio\n");
 #endif /* HAVE_SINK_APPLE_AUDIO */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink_apple_audio.c
===================================================================
--- tests/src/io/test-sink_apple_audio.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink_apple_audio.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -64,4 +66,7 @@
   PRINT_ERR("aubio was not compiled with aubio_source_apple_audio\n");
 #endif /* HAVE_SINK_APPLE_AUDIO */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink_sndfile-multi.c
===================================================================
--- tests/src/io/test-sink_sndfile-multi.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink_sndfile-multi.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -75,4 +77,7 @@
   PRINT_ERR("aubio was not compiled with aubio_sink_sndfile\n");
 #endif /* HAVE_SNDFILE */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink_sndfile.c
===================================================================
--- tests/src/io/test-sink_sndfile.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink_sndfile.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -64,4 +66,7 @@
   PRINT_ERR("aubio was not compiled with aubio_source_sndfile\n");
 #endif /* HAVE_SNDFILE */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink_wavwrite-multi.c
===================================================================
--- tests/src/io/test-sink_wavwrite-multi.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink_wavwrite-multi.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -75,4 +77,7 @@
   PRINT_ERR("aubio was not compiled with aubio_sink_wavwrite\n");
 #endif /* HAVE_WAVWRITE */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-sink_wavwrite.c
===================================================================
--- tests/src/io/test-sink_wavwrite.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-sink_wavwrite.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -64,4 +66,7 @@
   PRINT_ERR("aubio was not compiled with aubio_sink_wavwrite\n");
 #endif /* HAVE_WAVWRITE */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-source.c
===================================================================
--- tests/src/io/test-source.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   uint_t err = 0;
   if (argc < 2) {
@@ -56,4 +58,5 @@
   del_aubio_source (s);
 beach:
+  aubio_cleanup();
   return err;
 }
Index: tests/src/io/test-source_apple_audio.c
===================================================================
--- tests/src/io/test-source_apple_audio.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source_apple_audio.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   uint_t err = 0;
   if (argc < 2) {
@@ -60,4 +62,7 @@
   PRINT_ERR("aubio was not compiled with aubio_source_apple_audio\n");
 #endif /* HAVE_SOURCE_APPLE_AUDIO */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-source_avcodec.c
===================================================================
--- tests/src/io/test-source_avcodec.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source_avcodec.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   uint_t err = 0;
   if (argc < 2) {
@@ -60,4 +62,7 @@
   PRINT_ERR("aubio was not compiled with aubio_source_avcodec\n");
 #endif /* HAVE_LIBAV */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-source_multi.c
===================================================================
--- tests/src/io/test-source_multi.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source_multi.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
   if (argc < 2) {
@@ -54,4 +56,6 @@
 beach:
 
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-source_seek.c
===================================================================
--- tests/src/io/test-source_seek.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source_seek.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   uint_t err = 0;
   if (argc < 2) {
@@ -89,4 +91,7 @@
   // check that we got about half the frames, with 3 decimals
   assert ( roundf(1.e3 * old_n_frames_1 / old_n_frames_3) / 1.e3 == 2.);
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-source_sndfile.c
===================================================================
--- tests/src/io/test-source_sndfile.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source_sndfile.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   uint_t err = 0;
   if (argc < 2) {
@@ -60,4 +62,7 @@
   PRINT_ERR("aubio was not compiled with aubio_source_sndfile\n");
 #endif /* HAVE_SNDFILE */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/io/test-source_wavread.c
===================================================================
--- tests/src/io/test-source_wavread.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/io/test-source_wavread.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   uint_t err = 0;
   if (argc < 2) {
@@ -61,4 +63,7 @@
   PRINT_ERR("aubio was not compiled with aubio_source_wavread\n");
 #endif /* HAVE_WAVREAD */
+
+  aubio_cleanup();
+  
   return err;
 }
Index: tests/src/onset/test-onset.c
===================================================================
--- tests/src/onset/test-onset.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/onset/test-onset.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+  
   uint_t err = 0;
   if (argc < 2) {
Index: tests/src/pitch/test-pitch.c
===================================================================
--- tests/src/pitch/test-pitch.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitch.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   // 1. allocate some memory
   uint_t n = 0; // frame counter
Index: tests/src/pitch/test-pitchfcomb.c
===================================================================
--- tests/src/pitch/test-pitchfcomb.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitchfcomb.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,5 @@
 int main (void)
 {
+  aubio_init();
   uint_t i = 0;
   uint_t win_s = 1024; // window size
Index: tests/src/pitch/test-pitchmcomb.c
===================================================================
--- tests/src/pitch/test-pitchmcomb.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitchmcomb.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t n = 10; // compute n times
   uint_t win_s = 1024; // window size
Index: tests/src/pitch/test-pitchschmitt.c
===================================================================
--- tests/src/pitch/test-pitchschmitt.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitchschmitt.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,5 @@
 int main (void)
 {
+  aubio_init();
   uint_t n = 10; // compute n times
   uint_t win_s = 1024; // window size
Index: tests/src/pitch/test-pitchspecacf.c
===================================================================
--- tests/src/pitch/test-pitchspecacf.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitchspecacf.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t n = 10; // compute n times
   uint_t win_s = 1024; // window size
Index: tests/src/pitch/test-pitchyin.c
===================================================================
--- tests/src/pitch/test-pitchyin.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitchyin.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t n = 10; // compute n times
   uint_t win_s = 1024; // window size
Index: tests/src/pitch/test-pitchyinfft.c
===================================================================
--- tests/src/pitch/test-pitchyinfft.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/pitch/test-pitchyinfft.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -8,4 +8,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t n = 10; // compute n times
   uint_t win_s = 1024; // window size
Index: tests/src/spectral/test-awhitening.c
===================================================================
--- tests/src/spectral/test-awhitening.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-awhitening.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+
   sint_t err = 0;
 
@@ -80,4 +82,5 @@
   del_fvec(vec);
 beach_fvec:
+  aubio_cleanup();
   return err;
 }
Index: tests/src/spectral/test-fft.c
===================================================================
--- tests/src/spectral/test-fft.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-fft.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   int return_code = 0;
   uint_t i, n_iters = 100; // number of iterations
@@ -44,5 +46,7 @@
   del_cvec(fftgrain);
   del_fvec(out);
+
   aubio_cleanup();
+  
   return return_code;
 }
Index: tests/src/spectral/test-filterbank.c
===================================================================
--- tests/src/spectral/test-filterbank.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-filterbank.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t win_s = 1024; // window size
   uint_t n_filters = 13; // number of filters
@@ -34,4 +36,5 @@
   del_cvec (in_spec);
   del_fvec (out_filters);
+  
   aubio_cleanup ();
 
Index: tests/src/spectral/test-filterbank_mel.c
===================================================================
--- tests/src/spectral/test-filterbank_mel.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-filterbank_mel.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t samplerate = 16000; // samplerate of signal to filter
   uint_t win_s = 512; // fft size
@@ -33,4 +35,5 @@
   del_cvec (in_spec);
   del_fvec (out_filters);
+  
   aubio_cleanup ();
 
Index: tests/src/spectral/test-mfcc.c
===================================================================
--- tests/src/spectral/test-mfcc.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-mfcc.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t win_s = 512; // fft size
   uint_t n_filters = 40; // number of filters
@@ -25,4 +27,5 @@
   del_cvec (in);
   del_fvec (out);
+  
   aubio_cleanup ();
 
Index: tests/src/spectral/test-phasevoc.c
===================================================================
--- tests/src/spectral/test-phasevoc.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-phasevoc.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t n = 6; // compute n times
   uint_t win_s = 32; // window size
@@ -42,4 +44,5 @@
   del_fvec(out);
   del_aubio_pvoc(pv);
+  
   aubio_cleanup();
 
Index: tests/src/spectral/test-specdesc.c
===================================================================
--- tests/src/spectral/test-specdesc.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-specdesc.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t win_s = 1024; // window size
   cvec_t *in = new_cvec (win_s); // input buffer
@@ -39,4 +41,5 @@
   del_cvec (in);
   del_fvec (out);
+  
   aubio_cleanup ();
 
Index: tests/src/spectral/test-tss.c
===================================================================
--- tests/src/spectral/test-tss.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/spectral/test-tss.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t n = 10; // compute n times
   uint_t win_s = 1024; // window size
Index: tests/src/synth/test-sampler.c
===================================================================
--- tests/src/synth/test-sampler.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/synth/test-sampler.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+  
   sint_t err = 0;
 
@@ -54,4 +56,5 @@
   del_aubio_sink(sink);
   del_fvec(vec);
+  
   aubio_cleanup();
 
Index: tests/src/synth/test-wavetable.c
===================================================================
--- tests/src/synth/test-wavetable.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/synth/test-wavetable.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+  
   sint_t err = 0;
 
@@ -63,4 +65,5 @@
   del_aubio_sink(sink);
   del_fvec(vec);
+  
   aubio_cleanup();
 
Index: tests/src/tempo/test-beattracking.c
===================================================================
--- tests/src/tempo/test-beattracking.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/tempo/test-beattracking.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -6,4 +6,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t i = 0;
   uint_t win_s = 1024; // window size
@@ -34,4 +36,5 @@
   del_fvec(in);
   del_fvec(out);
+  
   aubio_cleanup();
 
Index: tests/src/tempo/test-tempo.c
===================================================================
--- tests/src/tempo/test-tempo.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/tempo/test-tempo.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (int argc, char **argv)
 {
+  aubio_init();
+  
   uint_t err = 0;
   if (argc < 2) {
@@ -57,4 +59,5 @@
   del_fvec(out);
   del_aubio_source(source);
+  
 beach:
   aubio_cleanup();
Index: tests/src/temporal/test-a_weighting.c
===================================================================
--- tests/src/temporal/test-a_weighting.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/temporal/test-a_weighting.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,5 +3,6 @@
 int main (void)
 {
-  
+  aubio_init();
+
   aubio_filter_t * f;
 
@@ -39,4 +40,6 @@
   del_aubio_filter (f);
 
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/temporal/test-biquad.c
===================================================================
--- tests/src/temporal/test-biquad.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/temporal/test-biquad.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t win_s = 64; // window size
 
@@ -29,4 +31,6 @@
   del_fvec(out_vec);
 
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/temporal/test-c_weighting.c
===================================================================
--- tests/src/temporal/test-c_weighting.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/temporal/test-c_weighting.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+
   aubio_filter_t * f;
 
@@ -38,4 +40,6 @@
   del_aubio_filter (f);
 
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/temporal/test-filter.c
===================================================================
--- tests/src/temporal/test-filter.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/temporal/test-filter.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+  
   uint_t win_s = 16; // window size
   uint_t impulse_at = win_s / 2;
@@ -30,4 +32,5 @@
   del_fvec (out);
   del_aubio_filter (o);
+  
   aubio_cleanup ();
 
Index: tests/src/temporal/test-resampler.c
===================================================================
--- tests/src/temporal/test-resampler.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/temporal/test-resampler.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -3,4 +3,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t win_s = 1024; // window size
   smpl_t ratio = 0.5;
@@ -19,4 +21,6 @@
   del_fvec (out);
 
+  aubio_cleanup();
+
   return 0;
 }
Index: tests/src/test-cvec.c
===================================================================
--- tests/src/test-cvec.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-cvec.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t i, window_size = 16; // window size
   cvec_t * complex_vector = new_cvec (window_size); // input buffer
@@ -45,4 +47,7 @@
   // destroy it
   del_cvec(complex_vector);
+
+  aubio_cleanup();
+
   return 0;
 }
Index: tests/src/test-delnull.c
===================================================================
--- tests/src/test-delnull.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-delnull.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -7,4 +7,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t return_code = 0;
   fvec_t *f = new_fvec(-12);
@@ -21,4 +23,7 @@
     return_code = 3;
   }
+
+  aubio_cleanup();
+  
   return return_code;
 }
Index: tests/src/test-fmat.c
===================================================================
--- tests/src/test-fmat.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-fmat.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -7,4 +7,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t height = 3, length = 9, i, j;
   // create fmat_t object
@@ -26,4 +28,7 @@
   // destroy it
   del_fmat(mat);
+
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/test-fvec.c
===================================================================
--- tests/src/test-fvec.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-fvec.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t vec_size = 10, i;
   fvec_t * vec = new_fvec (vec_size);
@@ -39,4 +41,6 @@
   del_fvec(vec);
 
+  aubio_cleanup();
+
   return 0;
 }
Index: tests/src/test-lvec.c
===================================================================
--- tests/src/test-lvec.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-lvec.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t win_s = 32; // window size
   lvec_t * sp = new_lvec (win_s); // input buffer
@@ -14,4 +16,7 @@
   lvec_print (sp);
   del_lvec(sp);
+
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/test-mathutils-window.c
===================================================================
--- tests/src/test-mathutils-window.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-mathutils-window.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -4,4 +4,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t length = 0;
   uint_t n_length = 4, n_types = 10, i, t;
@@ -27,4 +29,7 @@
     }
   }
+
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/test-mathutils.c
===================================================================
--- tests/src/test-mathutils.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/test-mathutils.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -114,7 +114,12 @@
 int main (void)
 {
+  aubio_init();
+
   test_next_power_of_two();
   test_miditofreq();
   test_freqtomidi();
+
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/utils/test-hist.c
===================================================================
--- tests/src/utils/test-hist.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/utils/test-hist.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -5,4 +5,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t length;
   for (length = 1; length < 10; length ++ ) {
@@ -26,4 +28,7 @@
     del_fvec(t);
   }
+
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/utils/test-log.c
===================================================================
--- tests/src/utils/test-log.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/utils/test-log.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -24,4 +24,6 @@
 int main (void)
 {
+  aubio_init();
+
   fprintf(stdout, "### testing normal logging\n");
   AUBIO_ERR("testing normal AUBIO_LOG_ERR\n");
@@ -57,4 +59,6 @@
   AUBIO_DBG("testing again normal AUBIO_LOG_DBG\n");
 
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/utils/test-parameter.c
===================================================================
--- tests/src/utils/test-parameter.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/utils/test-parameter.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -25,4 +25,6 @@
 int main (void)
 {
+  aubio_init();
+
   smpl_t max_value = 100.;
   smpl_t min_value = 0.;
@@ -67,4 +69,6 @@
   del_aubio_parameter (param);
 
+  aubio_cleanup();
+  
   return 0;
 }
Index: tests/src/utils/test-scale.c
===================================================================
--- tests/src/utils/test-scale.c	(revision 2f02d518ef1e6fa0f3762057eefef78e68246d2b)
+++ tests/src/utils/test-scale.c	(revision 4b943729b9f24bb74b253030e772ae12ddc01f49)
@@ -5,4 +5,6 @@
 int main (void)
 {
+  aubio_init();
+
   uint_t n = 0;
   uint_t win_s = 1024; // window size
@@ -19,4 +21,6 @@
   del_fvec(in);
 
+  aubio_cleanup();
+  
   return 0;
 }